#ifndef __FIELD__
#define __FIELD__

using XMLIOSERVER::XML::XMLNode;
using XMLIOSERVER::XML::THashAttributes;

namespace XMLIOSERVER
{
   class CGrid; // CGRID = CDOMAINE + CAXIS
   class CFile;

   class CField : public ObjectTemplate<CField>, public FieldAttribut
   {
      public:

         CField(void) : ObjectTemplate<CField>(), FieldAttribut(), lastStored(NULL), grid(NULL), file(NULL)
         {/* Ne rien faire de plus */}
         CField(const string& _id) : ObjectTemplate<CField>(_id), FieldAttribut(), lastStored(NULL), grid(NULL), file(NULL)
         {/* Ne rien faire de plus */}

         static string GetName(void) { return ("field"); }
         static string GetDefName(void)  { return (CField::GetName()); }

         inline void solveGridRef(void) ;

         const CGrid* getGrid(void) const { return (grid); }
         const Array<double, 1>& getData(void) const { return (data); }

         void initLastStoredDate(const Date& _newlastStored)
         { if(lastStored == NULL) lastStored = new Date(_newlastStored); };

         bool isStorable(const Date& currDate)
         {
            if (lastStored == NULL) return (false);
            if (freq_op.hasValue())
               return (currDate >= (*lastStored + (Duration)freq_op));
            return (true);
         }

         void storeData(const Array<double, 1> & arr, const Date& currDate)
         {
            *lastStored = currDate;
            data.resize(shape(arr.size())) ;
            data = arr;
         }

         const CFile* getRelFile(void) const { return (file); }
         void setRelFile(CFile* _file) { file = _file; }

         virtual CField* getReference(void) const
         {
            if(!field_ref.hasValue()) return (NULL);
            if (!CField::HasObject(field_ref))
            { WARNING("Référence invalide sur l'objet "+GetName()+" nommé \""+((string)field_ref)+"\""); return (NULL); }

            return (CField::GetObject(field_ref));
         }

         virtual ~CField(void)
         { if(lastStored !=  NULL) delete lastStored; }

      private :

         Date* lastStored;

         CGrid* grid ;
         CFile* file;

         Array<double, 1>  data;

   }; // class CField

} // namespace XMLIOSERVER

DECLARE_GROUP(Field)

#endif // __FIELD__
